/* stor_init_test */

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <stor.h>

char *Progname;

int
main(int argc, char *argv[])
{
    char str[200];
    int ret;

    Progname = argv[0];

    system("/bin/rm -r testdata");
    ret = stor_init("testdata", 100);
    if (ret != 0) {
	fprintf(stderr,"%s: expect 0, got %d\n", Progname, ret);
	fprintf(stderr,"error message is:\n");
	fprintf(stderr,"\t%s\n", stor_strerror());
	return -1;
    }

    ret = stor_get_cur_run();
    if (ret != 0) {
	fprintf(stderr,"%s: stor_get_cur_run: expect run 0, got run %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_get_cur_file();
    if (ret != 0) {
	fprintf(stderr,"%s: stor_get_cur_file: expect file 0, got file %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_bytes_cur_file();
    if (ret != 0) {
	fprintf(stderr,"%s: stor_bytes_cur_file: expect 0, got %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_total_bytes();
    if (ret != 0) {
	fprintf(stderr,"%s: stor_total_bytes: expect 0, got %d\n",
	    Progname, ret);
	return -1;
    }

    stor_get_cur_run_str(str);
    if (strcmp(str, "00000") != 0) {
	fprintf(stderr,"%s: stor_cur_run_str: wanted '00000', got '%s'\n",
	    Progname, str);
	return -1;
    }

    stor_get_cur_file_str(str);
    if (strcmp(str, "000000") != 0) {
	fprintf(stderr,"%s: stor_cur_run_str: wanted '000000', got '%s'\n",
	    Progname, str);
	return -1;
    }

    stor_cur_file_path(str);
    if (strcmp(str, "testdata/00000/000000") != 0) {
	fprintf(stderr,
	    "%s: stor_cur_run_str: wanted 'testdata/00000/000000', got '%s'\n",
	    Progname, str);
	return -1;
    }

    system("/bin/rm -r testdata");
    return 0;
}
