/* stor_next_run_test */

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <stor.h>

char *Progname;

int
main(int argc, char *argv[])
{
    int i;
    int ret;
    char str[200];
    char tmpstr[100];

    Progname = argv[0];

    system("/bin/rm -r testdata");
    ret = stor_init("testdata", 100);
    if (ret != 0) {
	fprintf(stderr,"%s: expect 0, got %d\n", Progname, ret);
	fprintf(stderr,"error message is:\n");
	fprintf(stderr,"\t%s\n", stor_strerror());
	return -1;
    }

    for (i=0; i<10; i++) {
	ret = stor_next_run();
	if (ret != 0) {
	    fprintf(stderr,"%s: stor_next_run (loop %d): expect 0, got %d\n", 
	    	Progname, i, ret);
	    return -1;
	}

	ret = stor_get_cur_run();
	if (ret != i+1) {
	    fprintf(stderr,
	    	"%s: stor_get_cur_run (loop %d): expect run %d, got run %d\n",
		Progname, i, i+1, ret);
	    return -1;
	}
	sprintf(tmpstr, "%05d", ret);

	stor_get_cur_run_str(str);
	if (strcmp(str, tmpstr) != 0) {
	    fprintf(stderr,
	    	"%s: stor_cur_run_str (loop %d): wanted '%s', got '%s'\n",
		Progname, i, tmpstr, str);
	    return -1;
	}

	sprintf(tmpstr, "testdata/%05d/000000", i+1);
	stor_cur_file_path(str);
	if (strcmp(str, tmpstr) != 0) {
	    fprintf(stderr,
		"%s: stor_cur_file_path (loop %d) : wanted '%s', got '%s'\n",
		Progname, i, tmpstr, str);
	    return -1;
	}
    }

    system("/bin/rm -r testdata");
    return 0;
}
