/* stor_save_data_test */

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <stor.h>

char *Progname;

int
main(int argc, char *argv[])
{
    int i;
    int ret;
    char str[200];
    char tmpstr[100];

    Progname = argv[0];

    system("/bin/rm -r testdata");
    ret = stor_init("testdata", 100);
    if (ret != 0) {
	fprintf(stderr,"%s: expect 0, got %d\n", Progname, ret);
	fprintf(stderr,"error message is:\n");
	fprintf(stderr,"\t%s\n", stor_strerror());
	return -1;
    }

    for (i=0; i<10; i++) {
	sprintf(str, "abcdefgh%02d", i);
	ret = stor_save_data((unsigned char *)str, 1, 10);
	if (ret != 0) {
	    fprintf(stderr,"%s: stor_save_data (loop %d): expect 0, got %d\n", 
	    	Progname, i, ret);
	    return -1;
	}
    }
    sprintf(str, "abcdefgh10");
    ret = stor_save_data((unsigned char *)str, 1, 10);
    if (ret != 1) {
	fprintf(stderr,"%s: stor_save_data: expect 1, got %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_get_cur_file();
    if (ret != 1) {
	fprintf(stderr,
	    "%s: stor_get_cur_file: expect file 1, got file %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_get_cur_run();
    if (ret != 0) {
	fprintf(stderr,"%s: stor_get_cur_run: want 0, got %d\n",
	    Progname, ret);
	return -1;
    }

    stor_close();
    ret = stor_init("testdata", 100);
    if (ret != 0) {
	fprintf(stderr,"%s: expect 0, got %d\n", Progname, ret);
	fprintf(stderr,"error message is:\n");
	fprintf(stderr,"\t%s\n", stor_strerror());
	return -1;
    }

    for (i=0; i<10; i++) {
	sprintf(str, "abcdefgh%02d", i);
	ret = stor_save_data((unsigned char *)str, 1, 10);
	if (ret != 0) {
	    fprintf(stderr,"%s: stor_save_data (loop %d): expect 0, got %d\n", 
	    	Progname, i, ret);
	    return -1;
	}
    }
    sprintf(str, "abcdefgh10");
    ret = stor_save_data((unsigned char *)str, 1, 10);
    if (ret != 1) {
	fprintf(stderr,"%s: stor_save_data: expect 1, got %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_get_cur_file();
    if (ret != 1) {
	fprintf(stderr,
	    "%s: stor_get_cur_file: expect file 1, got file %d\n",
	    Progname, ret);
	return -1;
    }

    ret = stor_get_cur_run();
    if (ret != 1) {
	fprintf(stderr,"%s: stor_get_cur_run: want 1, got %d\n",
	    Progname, ret);
	return -1;
    }

    for (i=0; i<100; i++) {
	sprintf(str, "abcdefgh%02d", i);
	ret = stor_save_data((unsigned char *)str, 1, 10);
	if (ret < 0) {
	    fprintf(stderr,
	    	"%s: stor_save_data (loop %d): expect 0 or 1, got %d\n", 
	    	Progname, i, ret);
	    return -1;
	}
    }

    ret = stor_get_cur_file();
#ifdef NOTDEF
    printf("ret is %d\n", ret);
#else
    if (ret != 11) {
	fprintf(stderr,
	    "%s: stor_get_cur_file: expect file 11, got file %d\n",
	    Progname, ret);
	return -1;
    }
#endif


    system("/bin/rm -r testdata");
    return 0;
}
