/* stor_init_test */

#include <stor.hpp>
#include <string>
#include <iostream>
using namespace std;

#include <cstdio>
#include <cstring>
#include <cerrno>
#include <cstdlib>

char *Progname;

int
main(int argc, char *argv[])
{
    long ret;

    Progname = argv[0];

    system("/bin/rm -rf testdata");
    try {
	stor st("testdata", 100);

	ret = st.cur_run();
	if (ret != 0) {
	    cerr << Progname
	    	<< ": st.cur_run: expect run 0, got " << ret << endl;
	    return -1;
	}

	ret = st.cur_file();
	if (ret != 0) {
	    cerr << Progname
	    	<< ": st.cur_file: expect file 0, got " << ret << endl;
	    return -1;
	}

	ret = st.bytes_cur_file();
	if (ret != 0) {
	    cerr << Progname
	    	<< ": st.bytes_cur_file: expect 0, got " << ret << endl;
	    return -1;
	}

	ret = st.total_bytes();
	if (ret != 0) {
	    cerr << Progname
	    	<< ": st.total_bytes: expect 0, got " << ret << endl;
	    return -1;
	}

	string str = st.cur_run_str();
	if (str != "00000") {
	    cerr << Progname << ": st.cur_run_str: wanted '00000', got "
		<< str << endl;
	    return -1;
	}

	str = st.cur_file_str();
	if (str != "000000") {
	    cerr << Progname << ": st.cur_file_str: wanted '000000', got "
		<< str << endl;
	    return -1;
	}

	str = st.cur_file_path();
	if (str != "testdata/00000/000000") {
	    cerr << Progname
		<< ": st.cur_file_str: wanted 'testdata/00000/000000', got "
		<< str << endl;
	    return -1;
	}

	system("/bin/rm -rf testdata");
	return 0;
    }
    catch (string e) {
	cerr << Progname << ": can't construct stor object: " << e << endl;
	return -1;
    }
}
