/* stor_multi_run_test */

#include <stor.hpp>
#include <string>
#include <iostream>
using namespace std;

#include <cstdio>
#include <cstring>
#include <cerrno>
#include <cstdlib>

char *Progname;

int
main(int argc, char *argv[])
{
    int i;
    int ret;
    char str[32];

    Progname = argv[0];

    system("/bin/rm -rf testdata");
    try {
	stor st("testdata", 100);

	for (i=0; i<10; i++) {
	    sprintf(str, "abcdefgh%02d", i);
	    ret = st.save_data(str, 10);
	    if (ret != 0) {
		cerr << Progname << ": save_data (loop " << i
		    << "): expect 0, got " << ret << endl;
		return -1;
	    }
	}
	sprintf(str, "abcdefgh10");
	ret = st.save_data(str, 10);
	if (ret != 1) {
	    cerr << Progname
	    	<< ": _save_data: expect 1, got " << ret << endl;
	    return -1;
	}

	ret = st.cur_file();
	if (ret != 1) {
	    cerr << Progname
		<< ": cur_file: expect file 1, got file " << ret << endl;
	    return -1;
	}

	ret = st.cur_run();
	if (ret != 0) {
	    cerr << Progname
	    	<< ": cur_run: (A) want 0, got " << ret << endl;
	    return -1;
	}
    }
    catch (string e) {
	cerr << Progname << ": (A) can't construct stor object: " << e << endl;
	return -1;
    }
    try {
	stor st("testdata", 100);

	for (i=0; i<10; i++) {
	    sprintf(str, "abcdefgh%02d", i);
	    ret = st.save_data(str, 10);
	    if (ret != 0) {
		cerr << Progname << ": save_data (loop " << i
		    << "): expect 0, got " << ret << endl;
		return -1;
	    }
	}
	sprintf(str, "abcdefgh10");
	ret = st.save_data(str, 10);
	if (ret != 1) {
	    cerr << Progname
	    	<< ": _save_data: expect 1, got " << ret << endl;
	    return -1;
	}

	ret = st.cur_file();
	if (ret != 1) {
	    cerr << Progname
		<< ": cur_file: expect file 1, got file " << ret << endl;
	    return -1;
	}

	ret = st.cur_run();
	if (ret != 1) {
	    cerr << Progname
	    	<< ": cur_run: (B) want 1, got " << ret << endl;
	    return -1;
	}

	for (i=0; i<100; i++) {
	    sprintf(str, "abcdefgh%02d", i);
	    ret = st.save_data(str, 10);
	    if (ret < 0) {
		cerr << Progname << ": save_data (loop " << i
		    << "): expect 0 or 1, got " << ret << endl;
		return -1;
	    }
	}

	ret = st.cur_file();
#ifdef NOTDEF
	cout << "ret is " << ret << endl;
#else
	if (ret != 11) {
	    cerr << Progname
	    	<< ": cur_file: expect file 11, got file " << ret << endl;
	    return -1;
	}
#endif

	/* increment the run number */
	st.next_run();

	/* make sure it is 2 */
	ret = st.cur_run();
	if (ret != 2) {
	    cerr << Progname
	    	<< ": cur_run: want 2, got " << ret << endl;
	    return -1;
	}

	/* and make sure the current file is 0 */
	ret = st.cur_file();
	if (ret != 0) {
	    cerr << Progname
	    	<< ": cur_file: expect file 0, got file " << ret << endl;
	    return -1;
	}
    }
    catch (string e) {
	cerr << Progname << ": (B) can't construct stor object: " << e << endl;
	return -1;
    }


    system("/bin/rm -rf testdata");
    return 0;
}
