/* stor_next_file_test */

#include <stor.hpp>
#include <string>
#include <iostream>
using namespace std;

#include <cstdio>
#include <cstring>
#include <cerrno>
#include <cstdlib>

char *Progname;

int
main(int argc, char *argv[])
{
    int i;
    int ret;
    char str[200];
    char tmpstr[100];

    Progname = argv[0];

    system("/bin/rm -rf testdata");
    try {
	stor st("testdata", 100);

	for (i=0; i<10; i++) {
	    ret = st.next_file();
	    if (ret != i+1) {
		cerr << Progname
		    << ": next_file (loop " << i
		    << "): expect " << i+1 << ", got " << ret << endl; 
		return -1;
	    }

	    ret = st.cur_file();
	    if (ret != i+1) {
		cerr << Progname
		    << ": cur_file (loop " << i
		    << "): expect file " << i+1 << ", got file " << ret << endl; 
		return -1;
	    }
	    sprintf(tmpstr, "%06d", ret);
	    string t1(tmpstr);
	    string t2(st.cur_file_str());
	    if (t1 != t2) {
		cerr << Progname
		    << ": cur_file_str (loop " << i << "): wanted "
		    << "'" << t1 << "', got '" << t2 << "'" << endl;
		return -1;
	    }

	    sprintf(tmpstr, "testdata/00000/%06d", i+1);
	    t1 = tmpstr;
	    t2 = st.cur_file_path();
	    if (t1 != t2) {
		cerr << Progname
		    << ": cur_file_path (loop " << i
		    << ": wanted " << t1 << ", got " << t2 << endl;
		return -1;
	    }
	    
	}
    }
    catch (string e) {
	cerr << Progname << ": (A) can't construct stor object: " << e << endl;
	return -1;
    }

    system("/bin/rm -rf testdata");
    return 0;
}
