/* stor_two_obj_test */

#include <cstdio>
#include <cstring>
#include <cerrno>
#include <cstdlib>
#include <string>

#include <stor.hpp>
#include <iostream>
using namespace std;

char *Progname;

int
main(int argc, char *argv[])
{
    int i;
    int ret;

    Progname = argv[0];

    system("/bin/rm -rf testdata testdata2");

    try {
	stor st("testdata", 100);
	stor st2("testdata2", 100);

	for (i=0; i<10; i++) {
	    st.next_run();
	    st2.next_run();

	    ret = st.cur_run();
	    if (ret != i+1) {
		cerr << Progname
		    << ": cur_run: (loop " << i << ") expect run "
		    << i+1 << ", got " << ret << endl;
		return -1;
	    }
	    char tmpstr[32];
	    sprintf(tmpstr, "%05d", ret);
	    string t1(tmpstr);
	    string t2(st.cur_run_str());
	    if (t1 != t2) {
		cerr << Progname
		    << ": cur_run_str (loop " << i
		    << ": wanted " << t1 << ", got " << t2 << endl;
		return -1;
	    }

	    ret = st2.cur_run();
	    if (ret != i+1) {
		cerr << Progname
		    << ": cur_run (2): (loop " << i << ") expect run "
		    << i+1 << ", got " << ret << endl;
		return -1;
	    }
	    sprintf(tmpstr, "%05d", ret);
	    t1 = tmpstr;
	    t2 = st2.cur_run_str();
	    if (t1 != t2) {
		cerr << Progname
		    << ": cur_run_str (2) (loop " << i
		    << ": wanted " << t1 << ", got " << t2 << endl;
		return -1;
	    }

	    sprintf(tmpstr, "testdata/%05d/000000", i+1);
	    t1 = tmpstr;
	    t2 = st.cur_file_path();
	    if (t1 != t2) {
		cerr << Progname
		    << ": cur_file_path (loop " << i
		    << ": wanted " << t1 << ", got " << t2 << endl;
		return -1;
	    }
	    sprintf(tmpstr, "testdata2/%05d/000000", i+1);
	    t1 = tmpstr;
	    t2 = st2.cur_file_path();
	    if (t1 != t2) {
		cerr << Progname
		    << ": cur_file_path (2) (loop " << i
		    << ": wanted " << t1 << ", got " << t2 << endl;
		return -1;
	    }
	}
    }
    catch (string e) {
	cerr << Progname << ": (A) can't construct stor object: "
	    << e << endl;
	return -1;
    }

    system("/bin/rm -rf testdata testdata2");
    return 0;
}
